package com.pokkt.demo.fragments;

import android.os.Bundle;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Toast;

import com.pokkt.PokktAds;
import com.pokkt.ad.demo.R;
import com.pokkt.demo.utility.SharedPrefsUtil;
import com.pokkt.sdk.models.PokktAdViewConfig;

import static com.pokkt.demo.utility.SharedPrefsUtilConstant.*;

public class PokktAdPlayerViewConfigFragment extends BaseFragment {

    // ui
    // edt_security_key
    private CheckBox chkBackButtonDisabled, chkShouldAllowMute, chkShouldCollectFeedback, chkAudioEnabled, chkShouldAllowSkip, chkShouldConfirmSkip;
    private EditText edtDefaultSkipTime, edtSkipConfirmMessage, edtSkipConfirmYesLabel, edtSkipConfirmNoLabel, edtSkipTimerMessage, edtIncentiveMessage;
    private Button btnClearData, btnSend;

    PokktAdViewConfig config = new PokktAdViewConfig();

    public PokktAdPlayerViewConfigFragment() {
        // Required empty public constructor
    }


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // getArguments here
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        View rootView = inflater.inflate(R.layout.fragment_pokkt_ad_player_view_config, container, false);

        btnClearData = (Button) findView(rootView, R.id.btnClearData);
        btnSend = (Button) findView(rootView, R.id.btnSend);
        chkBackButtonDisabled = (CheckBox) findView(rootView, R.id.chkBackButtonDisabled);
        chkShouldAllowMute = (CheckBox) findView(rootView, R.id.chkShouldAllowMute);
        chkShouldCollectFeedback = (CheckBox) findView(rootView, R.id.chkShouldCollectFeedback);
        chkAudioEnabled = (CheckBox) findView(rootView, R.id.chkAudioEnabled);
        chkShouldAllowSkip = (CheckBox) findView(rootView, R.id.chkShouldAllowSkip);
        chkShouldConfirmSkip = (CheckBox) findView(rootView, R.id.chkShouldConfirmSkip);

        edtDefaultSkipTime = (EditText) findView(rootView, R.id.edtDefaultSkipTime);
        edtSkipConfirmMessage = (EditText) findView(rootView, R.id.edtSkipConfirmMessage);
        edtSkipConfirmYesLabel = (EditText) findView(rootView, R.id.edtSkipConfirmYesLabel);
        edtSkipConfirmNoLabel = (EditText) findView(rootView, R.id.edtSkipConfirmNoLabel);
        edtSkipTimerMessage = (EditText) findView(rootView, R.id.edtSkipTimerMessage);
        edtIncentiveMessage = (EditText) findView(rootView, R.id.edtIncentiveMessage);

        btnClearData.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                clearData();
            }
        });
        btnSend.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                saveData();
                if (hasDefaultValues()) {
                    Toast.makeText(getActivity().getApplicationContext(), "Add user info to be sent to PokktSDK", Toast.LENGTH_SHORT).show();
                } else {
                    PokktAdViewConfig pokktAdPlayerViewConfig = new PokktAdViewConfig();
                    String defaultSkipTime = !TextUtils.isEmpty(edtDefaultSkipTime.getText().toString()) ? edtDefaultSkipTime.getText().toString() : "0";
                    pokktAdPlayerViewConfig.setDefaultSkipTime(Integer.valueOf(defaultSkipTime));
                    pokktAdPlayerViewConfig.setSkipConfirmMessage(edtSkipConfirmMessage.getText().toString());
                    pokktAdPlayerViewConfig.setSkipConfirmYesLabel(edtSkipConfirmYesLabel.getText().toString());
                    pokktAdPlayerViewConfig.setSkipConfirmNoLabel(edtSkipConfirmNoLabel.getText().toString());
                    pokktAdPlayerViewConfig.setSkipTimerMessage(edtSkipTimerMessage.getText().toString());
                    pokktAdPlayerViewConfig.setIncentiveMessage(edtIncentiveMessage.getText().toString());
                    pokktAdPlayerViewConfig.setBackButtonDisabled(chkBackButtonDisabled.isChecked());
                    pokktAdPlayerViewConfig.setShouldAllowMute(chkShouldAllowMute.isChecked());
                    pokktAdPlayerViewConfig.setShouldCollectFeedback(chkShouldCollectFeedback.isChecked());
                    pokktAdPlayerViewConfig.setAudioEnabled(chkAudioEnabled.isChecked());
                    pokktAdPlayerViewConfig.setShouldAllowSkip(chkShouldAllowSkip.isChecked());
                    pokktAdPlayerViewConfig.setShouldSkipConfirm(chkShouldConfirmSkip.isChecked());

                    PokktAds.setAdPlayerViewConfig(pokktAdPlayerViewConfig);
                }
            }
        });
        return rootView;
    }

    @Override
    public void onViewCreated(View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        // setting font
        setFont(btnClearData);
        setFont(findView(view, R.id.txt_ad_settings));
        setFont(findView(view, R.id.txtDefaultSkipTime));
        setFont(findView(view, R.id.txtSkipConfirmMessage));
        setFont(findView(view, R.id.txtSkipConfirmYesLabel));
        setFont(findView(view, R.id.txtSkipConfirmNoLabel));
        setFont(findView(view, R.id.txtSkipTimerMessage));
        setFont(findView(view, R.id.txtIncentiveMessage));

        setFont(chkBackButtonDisabled);
        setFont(chkShouldAllowMute);
        setFont(chkShouldCollectFeedback);
        setFont(chkAudioEnabled);
        setFont(chkShouldAllowSkip);
        setFont(chkShouldConfirmSkip);
        setFont(edtDefaultSkipTime);
        setFont(edtSkipConfirmMessage);
        setFont(edtSkipConfirmYesLabel);
        setFont(edtSkipConfirmNoLabel);
        setFont(edtSkipTimerMessage);
        setFont(edtIncentiveMessage);

        try {
            bindData();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void bindData() throws Exception {

        if (SharedPrefsUtil.getMapFromPref(getActivity().getApplicationContext(), PREF_AD_VIEW_PLAYER_CONFIG).size() > 0) {

            chkBackButtonDisabled.setChecked(SharedPrefsUtil.getBooleanPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG, KEY_BACK_BUTTON_DISABLED));

            chkShouldAllowMute.setChecked(SharedPrefsUtil.getBooleanPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG, KEY_SHOULD_ALLOW_MUTE));

            chkShouldCollectFeedback.setChecked(SharedPrefsUtil.getBooleanPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG, KEY_SHOULD_COLLECT_FEEDBACK));

            chkAudioEnabled.setChecked(SharedPrefsUtil.getBooleanPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG, KEY_AUDIO_ENALBED));

            chkShouldAllowSkip.setChecked(SharedPrefsUtil.getBooleanPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG, KEY_SHOULD_ALLOW_SKIP));

            chkShouldConfirmSkip.setChecked(SharedPrefsUtil.getBooleanPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG, KEY_SHOULD_SKIP_CONFIRM));

            edtDefaultSkipTime.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG, KEY_DEFAULT_SKIP_TIME));

            edtSkipConfirmMessage.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG, KEY_SKIP_CONFIRM_MESSAGE));

            edtSkipConfirmYesLabel.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG, KEY_SKIP_CONFIRM_YES_LABEL));

            edtSkipConfirmNoLabel.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG, KEY_SKIP_CONFIRM_NO_LABEL));

            edtSkipTimerMessage.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG, KEY_SKIP_TIMER_MESSAGE));

            edtIncentiveMessage.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG, KEY_INCENTIVE_MESSAGE));
        }
    }

    private void clearData() {

        chkBackButtonDisabled.setChecked(false);
        chkShouldAllowMute.setChecked(false);
        chkShouldCollectFeedback.setChecked(false);
        chkAudioEnabled.setChecked(false);
        chkShouldAllowSkip.setChecked(false);
        chkShouldConfirmSkip.setChecked(false);
        edtDefaultSkipTime.setText("");
        edtSkipConfirmMessage.setText("");
        edtSkipConfirmYesLabel.setText("");
        edtSkipConfirmNoLabel.setText("");
        edtSkipTimerMessage.setText("");
        edtIncentiveMessage.setText("");
    }

    @Override
    public void onDestroy() {
        saveData();
        super.onDestroy();
    }

    private boolean hasDefaultValues() {
        if (TextUtils.isEmpty(edtDefaultSkipTime.getText().toString()) &&
                TextUtils.isEmpty(edtSkipConfirmMessage.getText().toString()) &&
                TextUtils.isEmpty(edtSkipConfirmYesLabel.getText().toString()) &&
                TextUtils.isEmpty(edtSkipConfirmNoLabel.getText().toString()) &&
                TextUtils.isEmpty(edtSkipTimerMessage.getText().toString()) &&
                TextUtils.isEmpty(edtIncentiveMessage.getText().toString()) &&
                !chkBackButtonDisabled.isChecked() &&
                !chkShouldAllowMute.isChecked() &&
                !chkShouldCollectFeedback.isChecked() &&
                !chkAudioEnabled.isChecked() &&
                !chkShouldAllowSkip.isChecked() &&
                !chkShouldConfirmSkip.isChecked()) {
            return true;
        }
        return false;
    }

    private void saveData() {

        SharedPrefsUtil.clearSharedPref(getActivity().getApplicationContext(), PREF_AD_VIEW_PLAYER_CONFIG);

        if (!hasDefaultValues()) {
            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG,
                    KEY_DEFAULT_SKIP_TIME, edtDefaultSkipTime.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG,
                    KEY_SKIP_CONFIRM_MESSAGE, edtSkipConfirmMessage.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG,
                    KEY_SKIP_CONFIRM_YES_LABEL, edtSkipConfirmYesLabel.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG,
                    KEY_SKIP_CONFIRM_NO_LABEL, edtSkipConfirmNoLabel.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG,
                    KEY_SKIP_TIMER_MESSAGE, edtSkipTimerMessage.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG,
                    KEY_INCENTIVE_MESSAGE, edtIncentiveMessage.getText().toString());

            SharedPrefsUtil.setBooleanPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG,
                    KEY_BACK_BUTTON_DISABLED, chkBackButtonDisabled.isChecked());

            SharedPrefsUtil.setBooleanPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG,
                    KEY_SHOULD_ALLOW_MUTE, chkShouldAllowMute.isChecked());

            SharedPrefsUtil.setBooleanPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG,
                    KEY_SHOULD_COLLECT_FEEDBACK, chkShouldCollectFeedback.isChecked());

            SharedPrefsUtil.setBooleanPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG,
                    KEY_AUDIO_ENALBED, chkAudioEnabled.isChecked());

            SharedPrefsUtil.setBooleanPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG,
                    KEY_SHOULD_ALLOW_SKIP, chkShouldAllowSkip.isChecked());

            SharedPrefsUtil.setBooleanPref(getActivity().getApplicationContext(),
                    PREF_AD_VIEW_PLAYER_CONFIG,
                    KEY_SHOULD_SKIP_CONFIRM, chkShouldConfirmSkip.isChecked());
        }
    }
}
