package com.pokkt.demo.utility;

import android.content.Context;
import android.content.SharedPreferences;

import java.util.Map;

/**
 * Created by abhinav-rathore on 23-03-2015.
 */
public class SharedPrefsUtil {


    public static boolean getBooleanPref(Context cxt, String prefName, String key) throws Exception {
        SharedPreferences sp = cxt.getSharedPreferences(prefName, Context.MODE_PRIVATE);
        if (sp.contains(key)) {
            return sp.getBoolean(key, false);
        } else {
            throw new Exception("Key not found");
        }
    }

    public static void setBooleanPref(Context cxt, String prefName, String key, boolean value) {
        SharedPreferences sp = cxt.getSharedPreferences(prefName, Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = sp.edit();
        editor.putBoolean(key, value);
        editor.apply();

    }

    public static float getFloatPref(Context cxt, String prefName, String key) throws Exception {
        SharedPreferences sp = cxt.getSharedPreferences(prefName, Context.MODE_PRIVATE);
        if (sp.contains(key)) {
            return sp.getFloat(key, 0f);
        } else {
            throw new Exception("Key not found");
        }
    }

    public static void setFloatPref(Context cxt, String prefName, String key, float value) {
        SharedPreferences sp = cxt.getSharedPreferences(prefName, Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = sp.edit();
        editor.putFloat(key, value);
        editor.apply();

    }

    public static int getIntPref(Context cxt, String prefName, String key) throws Exception {
        SharedPreferences sp = cxt.getSharedPreferences(prefName, Context.MODE_PRIVATE);
        if (sp.contains(key)) {
            return sp.getInt(key, 0);
        } else {
            throw new Exception("Key not found");
        }
    }

    public static void setIntPref(Context cxt, String prefName, String key, int value) {
        SharedPreferences sp = cxt.getSharedPreferences(prefName, Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = sp.edit();
        editor.putInt(key, value);
        editor.apply();
    }

    public static long getLongPref(Context cxt, String prefName, String key) throws Exception {
        SharedPreferences sp = cxt.getSharedPreferences(prefName, Context.MODE_PRIVATE);
        if (sp.contains(key)) {
            return sp.getLong(key, 0L);
        } else {
            throw new Exception("Key not found");
        }

    }

    public static void setLongPref(Context cxt, String prefName, String key, long value) {
        SharedPreferences sp = cxt.getSharedPreferences(prefName, Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = sp.edit();
        editor.putLong(key, value);
        editor.apply();
    }

    public static String getStringPref(Context cxt, String prefName, String key) throws Exception {
        SharedPreferences sp = cxt.getSharedPreferences(prefName, Context.MODE_PRIVATE);
        if (sp.contains(key)) {
            return sp.getString(key, "");
        } else {
            throw new Exception("Key not found");
        }

    }

    public static void setStringPref(Context cxt, String prefName, String key, String value) {
        SharedPreferences sp = cxt.getSharedPreferences(prefName, Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = sp.edit();
        editor.putString(key, value);
        editor.apply();
    }

    public static void clearSharedPref(Context cxt, String prefName) {
        SharedPreferences sp = cxt.getSharedPreferences(prefName, Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = sp.edit();
        editor.clear();
        editor.apply();
    }

    public static Map<String, ?> getMapFromPref(Context cxt, String prefName) {
        SharedPreferences sp = cxt.getSharedPreferences(prefName, Context.MODE_PRIVATE);
        return sp.getAll();
    }

    public static void removeKey(Context cxt, String prefName, String key){
        SharedPreferences sp = cxt.getSharedPreferences(prefName, Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = sp.edit();
        editor.remove(key);
        editor.apply();
    }

//
//    abstract void 	registerOnSharedPreferenceChangeListener(SharedPreferences.OnSharedPreferenceChangeListener listener)
//    Registers menu_order_placed_successfully callback to be invoked when menu_order_placed_successfully change happens to menu_order_placed_successfully preference.
//    abstract void 	unregisterOnSharedPreferenceChangeListener(SharedPreferences.OnSharedPreferenceChangeListener listener)
//    Unregisters menu_order_placed_successfully previous callback.

}
